﻿<%@ Page Title="" Language="C#" MasterPageFile="~/Shared/MasterPage.master" ValidateRequest="false" %>

<%@ Import Namespace="System.IO" %>
<%@ Register Assembly="Typps" Namespace="Typps" TagPrefix="t" %>
<script runat="server">
    protected void Page_Load(object sender, EventArgs e)
    {

    }
    protected void ImagePicker_BrowseServerRequest(object sender, EventArgs e)
    {
        //This handler fires when :
        //1) You click the Browse Server button on the Image designer dialog for~ the first time
        //2) When you use the file upload button to upload an image, and then 
        //clicking Browse server again will trigger this
        //3) This is indeed the best place to enumerate your images and it fires during pre_render phase
        //this means quite late in the page life cycle giving you a lot of time to do other things
        //such as saving your files on the server during a file upload operation *before* building
        //the nodes for the gallery.
        PopulateImageGallery((ImagePicker)sender);
    }
    void PopulateImageGallery(ImagePicker ip)
    {
        //fill our image gallery with images browsable on the server
        string imagesDirectoryPath = Server.MapPath(@"~/Editor/Images/Imagepicker/");
        /*not the best example to set titles but it's easy for demo*/
        string[] billgates ={"If you can't make it good, at least make it look good",
                                "Life is not fair, get used to it",
                                "Your most unhappy customers are your greatest source of learning",
                                "Patience is a key element of success"};
        DirectoryInfo di = new DirectoryInfo(imagesDirectoryPath);
        if (di.Exists)
        {
            ip.ImageGalleryNode.Text = di.Name;//The folder
            //Now lets add all images to this parent node so
            //it seems like this : 
            /*
                - Images
                    - imageselection1.jpg
                    - Image2.jpg
             */
            FileInfo[] files = di.GetFiles();
            int index = 0;
            foreach (FileInfo file in files)
            {
                string pathToImageFile = ResolveUrl(
        string.Format(@"~/Editor/Images/Imagepicker/{0}", file.Name));
                //create a new HTreeNode
                HTreeNode tr1 = new HTreeNode();
                tr1.Text = file.Name;
                tr1.Value = pathToImageFile;
                tr1.ToolTip = billgates[index++];
                if (index == billgates.Length)
                    index = 0;//recycle, we just ran out of quotes
                //add it to the root node, since we only have one folder
                ip.ImageGalleryNode.ChildNodes.Add(tr1);
            }
        }
    }
</script>
<asp:Content ID="Content1" ContentPlaceHolderID="head" runat="Server">
	<title>
    Typps HTML Editor 
</title>
</asp:Content> 
<asp:Content ID="Content2" ContentPlaceHolderID="ContentPlaceHolder1" runat="Server">
	<h1>Typps HTML Editor</h1>
    <t:Editor ID="Editor1" Skin="KnightRider" Height="500px" EnableViewState="false" IconsMode="ImageSprites" runat="server">
        <EmbeddedImagePicker ID="ImagePicker1"
            ImageUploadEnabled="false"
            OnBrowseServerRequest="ImagePicker_BrowseServerRequest" runat="server">
        </EmbeddedImagePicker>
    </t:Editor>
    <br style="clear:both"/>
    <p>Documentation and more demos coming soon.</p>
</asp:Content>
