﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.ComponentModel.Design;
    using System.Drawing.Design;
    using System.Runtime.Serialization;
    using System.Text;
    using System.Web.UI;

    [CollectionDataContract]
    [KnownType(typeof(MediaItemThumbnail))]
    public class MediaFrameThumbnailCollection : StateManagedCollection
    {
        #region Fields

        private static readonly Type[] knownTypes;

        #endregion Fields

        #region Constructors

        static MediaFrameThumbnailCollection()
        {
            MediaFrameThumbnailCollection.knownTypes = new Type[] { typeof(MediaItemThumbnail) };
        }

        public MediaFrameThumbnailCollection()
        {
        }

        #endregion Constructors

        #region Indexers

        public MediaItemThumbnail this[int index]
        {
            get
            {
                return (MediaItemThumbnail)((IList)this)[index];
            }
            set
            {
                ((IList)this)[index] = value;
            }
        }

        #endregion Indexers

        #region Methods

        // Restricts to MediaItemThumbnail types, items that can be added to the collection
        public int Add(MediaItemThumbnail value)
        {
            return ((IList)this).Add(value);
        }

        public bool Contains(MediaItemThumbnail value)
        {
            // If value is not of type MediaItemThumbnail, this will return false.
            return ((IList)this).Contains(value);
        }

        public void CopyTo(MediaItemThumbnail[] CssStyleItemArray, int index)
        {
            base.CopyTo(CssStyleItemArray, index);
        }

        public int IndexOf(MediaItemThumbnail value)
        {
            return ((IList)this).IndexOf(value);
        }

        public void Insert(int index, MediaItemThumbnail value)
        {
            ((IList)this).Insert(index, value);
        }

        public void Remove(MediaItemThumbnail value)
        {
            ((IList)this).Remove(value);
        }

        protected override object CreateKnownType(int index)
        {
            return new MediaItemThumbnail();
        }

        protected override Type[] GetKnownTypes()
        {
            return MediaFrameThumbnailCollection.knownTypes;
        }

        protected override void OnClear()
        {
            base.OnClear();
        }

        protected override void OnInsert(int index, object value)
        {
            base.OnInsert(index, value);
            if (!(value is MediaItemThumbnail))
            {
                throw new ArgumentException("value must be of type MediaItemThumbnail.", "value");
            }
        }

        protected override void OnValidate(Object value)
        {
            if (value.GetType() != typeof(MediaItemThumbnail))
                throw new ArgumentException("value must be of type MediaItemThumbnail.", "value");
        }

        protected override void SetDirtyObject(object o)
        {
            if (o is MediaItemThumbnail)
            {
                ((MediaItemThumbnail)o).SetDirty();
            }
        }

        #endregion Methods
    }
}