﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    #region Enumerations

    public enum CssSelection
    {
        HtmlEditor = 1,
        ImagePicker = 2,
        MediaFrame = 3,
        ColorPicker = 4,
        UpdatePanelProgress = 5,
        SlidePane
    }

    #endregion Enumerations

    #region Delegates

    public delegate void CssSelectedIndexChangedEventHandler(object sender, CssSelectedIndexChangedEventArgs e);

    #endregion Delegates

    public class CssSelectedIndexChangedEventArgs : EventArgs
    {
        #region Fields

        string cssValue;
        CssSelection selectedIndexValue;

        #endregion Fields

        #region Constructors

        public CssSelectedIndexChangedEventArgs(CssSelection selectedIndex, string css)
        {
            selectedIndexValue = selectedIndex;
            cssValue = css;
        }

        #endregion Constructors

        #region Properties

        public string Css
        {
            get { return cssValue; }
            set { cssValue = value; }
        }

        public CssSelection SelectedIndex
        {
            get { return selectedIndexValue; }
            set { selectedIndexValue = value; }
        }

        #endregion Properties
    }
}