﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections.Generic;
    using System.Text;
    using System.Web;
    using System.Web.UI;
    using System.Web.UI.WebControls;

    #region Delegates

    public delegate void SlidePaneItemCommandEventHandler(object sender, SlidePaneItemCommandEventArgs e);

    #endregion Delegates

    public class SlidePaneItemCommandEventArgs : CommandEventArgs
    {
        #region Fields

        object commandSourceValue;
        SlidePaneItem templatedItemValue;

        #endregion Fields

        #region Constructors

        public SlidePaneItemCommandEventArgs(SlidePaneItem templatedItem, object commandSource, CommandEventArgs originalArgs)
            : base(originalArgs)
        {
            templatedItemValue = templatedItem;
            commandSourceValue = commandSource;
        }

        #endregion Constructors

        #region Properties

        public object CommandSource
        {
            get
            {
                return commandSourceValue;
            }
        }

        public SlidePaneItem TemplatedItem
        {
            get { return templatedItemValue; }
            set { templatedItemValue = value; }
        }

        #endregion Properties
    }
}