﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Text;

    #region Delegates

    public delegate void WhiteSpaceCheckedChangedEventHandler(object sender, WhiteSpaceCheckedChangedEventArgs e);

    #endregion Delegates

    public class WhiteSpaceCheckedChangedEventArgs
    {
        #region Fields

        bool checkedStatusValue = false;
        CssSelection selectedIndexValue;

        #endregion Fields

        #region Constructors

        public WhiteSpaceCheckedChangedEventArgs(bool checkedStatus, CssSelection selection)
        {
            checkedStatusValue = checkedStatus;
            selectedIndexValue = selection;
        }

        #endregion Constructors

        #region Properties

        public bool CheckedStatus
        {
            get { return checkedStatusValue; }
            set { checkedStatusValue = value; }
        }

        public CssSelection SelectedIndex
        {
            get { return selectedIndexValue; }
            set { selectedIndexValue = value; }
        }

        #endregion Properties
    }
}