﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections.Generic;
    using System.Linq;
    using System.Runtime.Serialization;
    using System.Text;
    using System.Web;

    [DataContract]
    public class HttpPostedFileItem
    {
        #region Fields

        string clientSideFilePathValue;
        string fieldIdValue;
        HttpPostedFile fileValue;

        #endregion Fields

        #region Constructors

        public HttpPostedFileItem(string fieldId,string filePath,HttpPostedFile file)
        {
            fieldIdValue = fieldId;
            clientSideFilePathValue = filePath;
            fileValue = file;
        }

        #endregion Constructors

        #region Properties

        public string ClientSideFilePath
        {
            get { return clientSideFilePathValue; }
        }

        [IgnoreDataMember]
        public string FieldId
        {
            get { return fieldIdValue; }
        }

        [IgnoreDataMember]
        public HttpPostedFile File
        {
            get { return fileValue; }
        }

        [DataMember(Name="serverSideFilePath")]
        public string ServerSideFilePath
        {
            get;
            set;
        }

        #endregion Properties
    }
}