﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections.Generic;
    using System.Runtime.Serialization;
    using System.Text;
    using System.Web;

    #region Delegates

    public delegate void UploadedFileEventHandler(object sender, UploadedFileEventArgs e);

    #endregion Delegates

    [DataContract]
    public class UploadedFileEventArgs : EventArgs
    {
        #region Fields

        string fieldIdValue;
        private HttpPostedFile postedFileValue;

        #endregion Fields

        #region Constructors

        public UploadedFileEventArgs(HttpPostedFile file)
        {
            postedFileValue = file;
        }

        public UploadedFileEventArgs(string fieldId,HttpPostedFile file)
        {
            fieldIdValue = fieldId;
            postedFileValue = file;
        }

        #endregion Constructors

        #region Properties

        [IgnoreDataMember]
        public string FieldId
        {
            get { return fieldIdValue; }
        }

        [IgnoreDataMember]
        public HttpPostedFile PostedFile
        {
            get { return postedFileValue; }
            set { postedFileValue = value; }
        }

        [DataMember(Name="serverSideFilePath")]
        public string ServerSideFilePath
        {
            get;
            set;
        }

        #endregion Properties
    }
}