﻿/*
____
 L|ypps Web controls for ASP.NET

Copyright (c) 2009 Alessandro Zifiglio, http://www.Typps.com
EMail: alessandro@Typps.com

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
namespace Typps
{
    using System;
    using System.Collections.Generic;
    using System.ComponentModel;
    using System.Text;
    using System.Web.UI;
    using System.Web.UI.WebControls;

    [ToolboxItem(false)]
    internal class HiddenFieldNoEncode : HiddenField
    {
        #region Methods

        protected override void Render(HtmlTextWriter writer)
        {
            string uniqueID = this.UniqueID;
            if (this.Page != null)
            {
                this.Page.VerifyRenderingInServerForm(this);
                this.Page.ClientScript.RegisterForEventValidation(uniqueID);
            }
            writer.AddAttribute(HtmlTextWriterAttribute.Type, "hidden");
            if (uniqueID != null)
            {
                writer.AddAttribute(HtmlTextWriterAttribute.Name, uniqueID);
            }
            if (this.ID != null)
            {
                writer.AddAttribute(HtmlTextWriterAttribute.Id, this.ClientID);
            }
            string text2 = this.Value;
            if (text2.Length > 0)
            {
                writer.AddAttribute(HtmlTextWriterAttribute.Value, text2, false);
            }
            writer.RenderBeginTag(HtmlTextWriterTag.Input);
            writer.RenderEndTag();
        }

        #endregion Methods
    }
}