namespace NetSpell.SpellChecker
{
    using System;

    /// <summary>
    /// Summary description for ReplaceWordEventArgs.
    /// </summary>
    public class ReplaceWordEventArgs : SpellingEventArgs
    {
        #region Fields

        private string _ReplacementWord;

        #endregion Fields

        #region Constructors

        /// <summary>
        ///     Class sent to the event handler when the ReplacedWord Event is fired
        /// </summary>
        public ReplaceWordEventArgs(string replacementWord, string word, int wordIndex, int textIndex)
            : base(word, wordIndex, textIndex)
        {
            _ReplacementWord = replacementWord;
        }

        #endregion Constructors

        #region Properties

        /// <summary>
        ///     The word to use in replacing the misspelled word
        /// </summary>
        public string ReplacementWord
        {
            get {return _ReplacementWord;}
        }

        #endregion Properties
    }
}