namespace Wilco.CodeHilighter.Engine.SyntaxHighlighting
{
    using System;
    using System.Collections.Specialized;

    /// <summary>
    /// Represents a comment block node.
    /// </summary>
    public class CommentBlockNode : NodeBase
    {
        #region Fields

        private EntityCollection entities;

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of a <see cref="Wilco.CodeHilighter.Engine.SyntaxHighlighting.CommentBlockNode"/> class.
        /// </summary>
        public CommentBlockNode()
        {
            this.entities = new EntityCollection();
        }

        #endregion Constructors

        #region Properties

        /// <summary>
        /// Gets the collection of entities which contains information about the start and end strings of comment blocks.
        /// </summary>
        public EntityCollection Entities
        {
            get
            {
                return this.entities;
            }
        }

        #endregion Properties
    }
}