namespace Wilco.CodeHilighter.Engine.SyntaxHighlighting
{
    using System;

    /// <summary>
    /// Represents an entity.
    /// </summary>
    public class Entity
    {
        #region Fields

        private string end;
        private string start;

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of a <see cref="Wilco.CodeHilighter.Engine.SyntaxHighlighting.Entity"/> struct.
        /// </summary>
        /// <param name="start">The string which indicates the start of a comment block.</param>
        /// <param name="end">The string which indicates the end of a comment block.</param>
        public Entity(string start, string end)
        {
            this.start = start;
            this.end = end;
        }

        #endregion Constructors

        #region Properties

        /// <summary>
        /// Gets the string which indicates the end of a comment block.
        /// </summary>
        public string End
        {
            get
            {
                return this.end;
            }
        }

        /// <summary>
        /// Gets the string which indicates the start of a comment block.
        /// </summary>
        public string Start
        {
            get
            {
                return this.start;
            }
        }

        #endregion Properties
    }
}