namespace Wilco.CodeHilighter.Engine.SyntaxHighlighting
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// Represents a comment line node.
    /// </summary>
    public class CommentLineNode : NodeBase
    {
        #region Fields

        private List<string> entities;

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of a <see cref="Wilco.CodeHilighter.Engine.SyntaxHighlighting.CommentLineNode"/> class.
        /// </summary>
        public CommentLineNode()
        {
            this.entities = new List<string>();
        }

        #endregion Constructors

        #region Properties

        /// <summary>
        /// Gets the collection of entities which indicate the start of a comment line.
        /// </summary>
        public List<string> Entities
        {
            get
            {
                return this.entities;
            }
        }

        #endregion Properties
    }
}