namespace Wilco.CodeHilighter.Engine.SyntaxHighlighting
{
    using System;
    using System.Collections.Generic;

    /// <summary>
    /// Represents a word node.
    /// </summary>
    public class WordNode : NodeBase
    {
        #region Fields

        private List<string> entities;
        private bool ignoreCase;

        #endregion Fields

        #region Constructors

        /// <summary>
        /// Initializes a new instance of a <see cref="Wilco.CodeHilighter.Engine.SyntaxHighlighting.WordNode"/> class.
        /// </summary>
        public WordNode()
        {
            this.entities = new List<string>();
        }

        #endregion Constructors

        #region Properties

        /// <summary>
        /// Gets the collection of entities which represent words.
        /// </summary>
        public List<string> Entities
        {
            get
            {
                return this.entities;
            }
        }

        /// <summary>
        /// Gets or sets whether case should be ignored.
        /// </summary>
        public bool IgnoreCase
        {
            get
            {
                return this.ignoreCase;
            }
            set
            {
                if (value != this.ignoreCase)
                {
                    this.ignoreCase = value;
                }
            }
        }

        #endregion Properties
    }
}